﻿using System.Collections.Generic;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Data;

namespace RadComboBoxInRadGridView
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			this.RadGridView1.ItemsSource = Person.getNames();

			
			this.RadGridView1.AutoGeneratingColumn += new System.EventHandler<GridViewAutoGeneratingColumnEventArgs>(RadGridView1_AutoGeneratingColumn);
		//	((GridViewComboBoxColumn)this.RadGridView1.Columns[1]).ItemsSource = Country.GetCountries();

		}

		void RadGridView1_AutoGeneratingColumn(object sender, GridViewAutoGeneratingColumnEventArgs e)
		{
			if(e.Column.UniqueName == "CountryID")
			{				
				e.Column = new GridViewComboBoxColumn();
				(e.Column as GridViewComboBoxColumn).DataMemberBinding = new Binding("CountryID");
				(e.Column as GridViewComboBoxColumn).ItemsSource = Country.GetCountries();				
				(e.Column as GridViewComboBoxColumn).DisplayMemberPath = "Name";
				(e.Column as GridViewComboBoxColumn).SelectedValueMemberPath = "ID";
				
			}
		}
	}

	public class Person : INotifyPropertyChanged
	{
		private string name;
		private int countryID;
		

		public string Name
		{
			get
			{
				return this.name;
			}
			set
			{
				if (this.name != value)
				{
					this.name = value;
					this.OnPropertyChanged("Name");

				}
			}
		}

		public int CountryID
		{
			get 
			{
				return this.countryID;
			}
			set 
			{
				if (this.countryID != value)
				{
					this.countryID = value;
					this.OnPropertyChanged("CountryID");
				}
			}
		}



		public Person(string name, int countryID)
		{
			this.name = name;
			this.countryID = countryID;

		}

		public static ObservableCollection<Person> getNames()
		{
			ObservableCollection<Person> names = new ObservableCollection<Person>();

			names.Add(new Person("Adam Debrovski", 1));
			names.Add(new Person("Juames Peterson",2));
			names.Add(new Person("Vladislav Znekovski",3));
			names.Add(new Person("Peter Borisov",2));
			names.Add(new Person("John Peterson", 2));

			return names;

		}

		public event PropertyChangedEventHandler PropertyChanged;

		void OnPropertyChanged(string property)
		{
			if (this.PropertyChanged != null)
				this.PropertyChanged(this, new PropertyChangedEventArgs(property));
		}

	}


	public class Country : INotifyPropertyChanged
	{
		public Country(int id, string name)
		{
			this.Name = name;
			this.id = id;
		}

		private int id;
		public int ID
		{
			get
			{
				return this.id;
			}
			set
			{
				this.id = value;
				this.OnPropertyChanged("ID");
			}
		}
		private string name;
		public string Name
		{
			get
			{
				return this.name;
			}
			set
			{
				this.name = value;
				this.OnPropertyChanged("Name");
			}
		}
		public static List<Country> GetCountries()
		{
			List<Country> countries = new List<Country>();
			countries.Add(new Country(1, "Spain"));
			countries.Add(new Country(2, "Germany"));
			countries.Add(new Country(3, "France"));


			return countries;
		}

		public event PropertyChangedEventHandler PropertyChanged;

		void OnPropertyChanged(string property)
		{
			if (this.PropertyChanged != null)
				this.PropertyChanged(this, new PropertyChangedEventArgs(property));
		}

	}
}

	
		


	

